
#include "stdafx.h"

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "NeofoxDLL.h"

int _tmain(int argc, _TCHAR* argv[])
{
  unsigned long ulParamType;
  unsigned long ulParamVal;
  int*          pnParamVal;
  bool          bDebug;
  int           hDevice;
  
  bDebug = (argc > 3) ? true: false;

  if (bDebug) 
  { 
    printf("\nNEOFOX PARAMETER WRITE\n");
  }

  if (argc < 3) 
  {
    if (bDebug)
    {
      printf("Error: Bad arguments\n");
      printf("Press any key to exit.");
      while (!_kbhit());
    }
    return -1;
  }

  ulParamType = strtoul(argv[1], NULL, 0);
  ulParamVal  = strtoul(argv[2], NULL, 0);
  pnParamVal   = (int*) &ulParamVal;
 
  ApplicationStartup(NULL);
  DevicePerformDiscovery(0x2457, 0x3000, 0);
  hDevice = DeviceOpenChannel(0, 0, 0);
  
  if (hDevice < 1) 
  {
    if (bDebug)
    {
      printf("Error: Could not connect to Neofox.\n Is it plugged in? Is any other software connected to it?\n");
      printf("Press any key to exit.");
      while (!_kbhit());
    }
    return -2;
  }
  
  if (bDebug)
  {
    printf("Param Type(U): %lu\n", ulParamType);
    printf("Param Val (U): %lu\n", ulParamVal);
    printf("Param Val (I): %d\n", *pnParamVal);
  }

  DeviceSetParameter(hDevice, ulParamType, *pnParamVal);
  DeviceClose(hDevice);
  ApplicationShutdown();
  
  if (bDebug)
  {
    printf("Press any key to exit.");
    while (!_kbhit());
  }

	return 0;
}